C    THIS IS A SET OF SHORT GRAPHICAL ROUTINES
C    WHICH REPLACE THE ORIGINAL CALCOMP CALLS
C    IN THE PROGRAM PSI2.F THE NAMES OF ROUTINES 
C    ARE THE SAME AS OF CALCOMP ROUTINES SO THAT
C    THE PROGRAM PSI2 CAN BE USED WITHOUT ANY MODIFICATION
C    THIS SET OF ROUTINES ONLY DOES THE SAME AS WOULD DO
C    THE CALCOMP ROUTINES.
C    THE ROUTINES WERE WRITTEN BY F.UHLIK AND R.PONEC
C    AT THE INSTITUTE OF CHEMICAL PROCESS FUNDMENTALS
C    OF THE CZECH ACADEMY OF SCIENCES, PRAGUE 6, SUCHDOL
C    E-MAIL:RPONEC@ICPF.CAS.CZ
C           UHLIK@SALS.ICPF.CAS.CZ 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      SUBROUTINE PLOTS(IDUM)
      USE MSFLIB
      LOGICAL MODESTATUS
      TYPE(WINDOWCONFIG) MYSCREEN
	integer(2) maxx,maxy,dummy
	common /max/ maxx,maxy
	MYSCREEN.NUMXPIXELS=-1
	MYSCREEN.NUMYPIXELS=-1
	MYSCREEN.NUMTEXTCOLS=-1
	MYSCREEN.NUMTEXTROWS=-1
	MYSCREEN.FONTSIZE=-1
	MYSCREEN.TITLE="PSI88"C
	MODESTATUS=SETWINDOWCONFIG(MYSCREEN)
      MODESTATUS=GETWINDOWCONFIG(MYSCREEN)
	maxx=myscreen.numxpixels
	maxy=myscreen.numypixels
	dummy=initializefonts()
	dummy=setfont('2')
	return
      end

	subroutine factor (f)
      real f
	integer(2) maxx,maxy
	common /pen/ fac,xori,yori,pen
	common /max/ maxx,maxy
	xori=0.0
	yori=0.0
	pen=1
	if(maxx.lt.maxy)then
	  fac=0.75*f*maxx/6.5
	else
	  fac=0.75*f*maxy/6.5
	end if
	return
	end

	subroutine symbol(x,y,h,s,a,n)
	use msflib
      real x,y,h,a
      integer n
	character*(*) s
	call plot(x,y,3)
	call outgtext(s)
	return
	end

	subroutine line (x,y,n,k,j,ocsym)
      character strocs
      integer ocsym
      dimension x(1),y(1)
c
c   plot pairs x,y scaled to minimum of
c   x(n*k+1),y(n*k+1), and increment per inch
c   of x(n*(k+1)),y(n*(k+1)).
c
c   x = horizontal array of points
c   y = vertical array of points
c   n = # of pairs of points to ploit in x and y
c   k = plot n points from the 1st, k+1st, 2,k+1st, etc..
c       positions of arrays x and y.
c   j = >0: plot symbol ocsym (hollerith) each jth point
c            with connected line
c   j =  0: plot only the line.
c   j = <0: plot only the symbols each jth point.
c
      n1 = n*k
      im = n1+1
      id = im+k
      if (x(id).eq.0.or.y(id).eq.0) return
      ipen = 2
      m = j
      if (j.lt.0) then
         m = -m
         ipen = 3
      endif
      x1 = (x(1)-x(im))/x(id)
      y1 = (y(1)-y(im))/y(id)
      call plot (x1,y1,3)
      jcnt = 0
      do 10 i = 1, n1, k
         jcnt = jcnt+1
         xp = (x(i)-x(im))/x(id)
         yp = (y(i)-y(im))/y(id)
         if (j.ne.0) then
            if (m.ne.jcnt) go to 10
            jcnt = 0
         endif
         call plot (xp,yp,ipen)
         if (j.ne.0) then
            strocs = char(ocsym)
            call symbol (xp,yp,.14,strocs,0.,-1)
            call plot (xp,yp,3)
         endif
   10 continue
      return
      end

	subroutine dshlin (x,y,n,dsh,gap,nsec)
      integer pen
      dimension x(1),y(1),dsh(1),gap(1)
c
      if (nsec.ne.0) then
c
c     initialize
c
         k = 1
         pen = 2
         s = 0.0
         t = dsh(1)
         xmin = x(n+1)
	   xinc = x(n+2)
         ymin = y(n+1)
         yinc = y(n+2)
c
c     move to first point
c
         x2 = (x(1)-xmin)/xinc
         y2 = (y(1)-ymin)/yinc
         call plot (x2,y2,3)
c
c     plot dashed line curve
c
         do 20 i = 2, n
   10       x1 = x2
            y1 = y2
            x2 = (x(i)-xmin)/xinc
            y2 = (y(i)-ymin)/yinc
            d = sqrt((x2-x1)**2+(y2-y1)**2)
            s = s+d
            if (s.ge.t) then
               x2 = x2+(x1-x2)*(s-t)/d
               y2 = y2+(y1-y2)*(s-t)/d
               call plot (x2,y2,pen)
               pen = 5-pen
               s = 0.0
               t = gap(k)
               if (pen.eq.3) go to 10
               k = mod(k,nsec)+1
               t = dsh(k)
               go to 10
            endif
            call plot (x2,y2,pen)
   20    continue
         return
      endif
      call line (x,y,n,1,0,0)
      return
      end

	subroutine line_to(x,y)
	use msflib
	integer*2 status
	status=lineto_w(x,y)
	return
	end

	subroutine move_to(x,y)
	use msflib
	real(8) xx,yy
	type (wxycoord) wxy
	xx=x
	yy=y
	call moveto_w(xx,yy,wxy)
	return
	end
	 
	subroutine plot(xx,yy,i)
c    x,y = coordinates, in inches from the current origin, of the position
c          to which the pen is to be moved
c
c    ipen = pen control, origin definition, and plot termiination such t
c      if ipen = 1, move with pen in present condition
c      if ipen = 2, move with pen down
c      if ipen = 3, move with pen up
c      if ipen = -1, move with no pen change, reset origin to terminal p
c      if ipen = -2, move with pen down, reset origin to terminal position
c      if ipen = -3, move with pen up, reset origin to terminal position
c      if ipen = 666, see 999.
c      if ipen = 999, move with pen up, terminate plot, close plot file
c      if ipen = anything else, no action is taken
c
	common /pen/ fac,xori,yori,pen
	x=xx*fac
	y=yy*fac
	select case (i)
	  case (1)
	    if(pen.eq.0)then
		  call line_to(xori+x,yori+y)
	    else 
		  call move_to(xori+x,yori+y)
	    end if
	  case (2)
	    pen=0
	    call line_to(xori+x,yori+y)
	  case (3)
	    pen=1
	    call move_to(xori+x,yori+y)
	  case (-1)
          xori=xori+x
	    yori=yori+y
	    if(pen.eq.0)then
		  call line_to(xori,yori)
	    else
		  call move_to(xori,yori)
	    end if
        case (-2)
	    xori=xori+x
	    yori=yori+y
   		pen=0
	    call line_to(xori,yori)
	  case (-3)
          xori=xori+x
          yori=yori+y
	    pen=1
	    call move_to(xori,yori)
	  case default
	end select    
	return
	end

	subroutine newpen(ipen)
	integer ipen
	return
	end


